/*
  climate.h - Weather FIGs generating utility / header part
  Copyright (C) 1999 Michael Jung
  e-mail: miju@phantasia.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#define MAXBUFLEN    40
#define SIZEALLOC(n,s) (s *) ( malloc( (n) * sizeof(s) ) ? : error(2) )
#define MAX(a,b)     ( (a) > (b) ? (a) : (b) )
#define MIN(a,b)     ( (a) < (b) ? (a) : (b) )

/* --- structs --- */

struct llist
{ int label; struct llist *next; };
typedef struct llist llist;

struct calender
{ int ndays; struct calender *next; };
typedef struct calender calender;

struct date
{ int w,d,m; };
typedef struct date date;

struct timespan
{ date *d1; date *d2; struct timespan *next; };
typedef struct timespan timespan;

struct weather
{
  llist          *labels;
  char           *cloud, *precip, *wdir, *wspeed, *temp;
  timespan       *tsptr;
  struct weather *next;
};
typedef struct weather weather;

struct table
{ char *local; timespan *tsptr; llist *lptr; struct table *next; };
typedef struct table table;

struct translate
{ llist *lptr; struct translate *next; };
typedef struct translate translate;

struct canvas
{ int w, h, ew, eh, ps, loff, ruoff, rloff, font, ndays; };
typedef struct canvas canvas;

struct cycle
{ char *name; struct cycle *next; };
typedef struct cycle cycle;

struct cycles
{ cycle *iptr, *cptr; int lvl; struct cycles *next; };
typedef struct cycles cycles;

struct jump
{ int *table; struct jump *next; };
typedef struct jump jump;

struct jumptable
{ llist *labels; jump *table; struct jumptable *next; };
typedef struct jumptable jumptable;

struct randnum
{ struct randnum *next; int num; };
typedef struct randnum randnum;
